/*###################################### 
# Fichier : main.cpp
# Fait par Fernandez Stephane 07 219 609
# Projet de session ift630
######################################*/


#include "Variables.h"
#include <semaphore.h> 

using namespace std;

void* resolutionThread(void* args);
void startThread(int nbThread, void* args);
sem_t semaphoreThreadCre;
sem_t semaphoreFinDeRecherche;

int main(int argc, char* argv[]){
	
	if(argc != 2){
			printf("Erreur d'arguments, vous devez mentionner la taille\n");
			return 0;
	}
	
	pthread_mutex_init(&solutionAcces,NULL);
	
	sem_init(&semaphoreThreadCre, 0, 0);
	sem_init(&semaphoreFinDeRecherche, 0, 0);
	
	struct timeval tv1,tv2;
	struct timezone tz;
	timespec slice;
	int nbElement;
	int * argv2;
	
	argv2= new int[2];
	nbElement=strtoul(argv[1], 0, 10);
	argv2[0]=nbElement;
	argv2[1]=0;
    time(&(slice.tv_sec));
    slice.tv_nsec=20000;
    gettimeofday(&tv1, &tz);
	// Resolution en squentiel
	Damier D(nbElement);
    while(D.Increase(0)){
		if( Solutions.EstUneSolution(D.GetEspace(),nbElement) )Solutions.AjouterSolution(D.GetEspace(),nbElement);
	}
	// Fin de rsolution
	gettimeofday(&tv2, &tz);
    tempo=(tv2.tv_sec-tv1.tv_sec)+((tv2.tv_usec-tv1.tv_usec)*0.000001);
    printf("Temps en sequentiel : %f\n",tempo);
    gettimeofday(&tv1, &tz);
    // Resolution en parallle
    startThread(nbElement,(void*)argv2);
    sem_wait(&semaphoreFinDeRecherche);
    // Fin de rsolution
    gettimeofday(&tv2, &tz);
    tempo=(tv2.tv_sec-tv1.tv_sec)+((tv2.tv_usec-tv1.tv_usec)*0.000001);
    
	printf("Temps en parallele : %f\n",tempo);
    printf("Solutions sequentielles : \n");
    Solutions.Affiche(nbElement);
    printf("Solutions paralleles : \n");
    SolutionsParallele.Affiche(nbElement);
	return 0;
}

void* resolutionThread(void* args){
	  Damier Dam(*(int *)args);
	  int numeroFixe=*((int *)args+1);
	  sem_post(&semaphoreThreadCre);
	  while(Dam.IncreaseParallele(0,numeroFixe)){
		if( SolutionsParallele.EstUneSolution(Dam.GetEspace(),*(int *)args) ){
			pthread_mutex_lock(&solutionAcces);
			SolutionsParallele.AjouterSolution(Dam.GetEspace(),*(int *)args);
			pthread_mutex_unlock(&solutionAcces);
			}	
	}
	  pthread_mutex_lock(&solutionAcces);
	  cmpt++;
	  if(cmpt==*(int *)args)sem_post(&semaphoreFinDeRecherche);
	  pthread_mutex_unlock(&solutionAcces);
}
	  
void startThread(int nbThread, void* args){
      int isr;
	  for(int i=0;i<*(int *)args;i++){
	        *((int *)args+1)=i;
	  	    isr = pthread_create(&threadResolution[i], NULL, resolutionThread, args);
			sem_wait(&semaphoreThreadCre);
		   	assert(isr == 0);
      }
}

	
